// THIS IS INTERNAL HEADER FILE
// Don't add it to \_Inc\Foundation.h

#ifndef COMMALLOCSPYIMPL_H_INCLUDED
#define COMMALLOCSPYIMPL_H_INCLUDED

#pragma once

#pragma warning(disable:4786)
#include <map>

class KComMallocSpyImpl : public IMallocSpy
{
    public:        
        explicit KComMallocSpyImpl( DWORD Flags );
        virtual ~KComMallocSpyImpl();

        enum { ENABLE_TRACE = 1 };

        void CheckLeaks();

    public:

        // IUnknown methods
        STDMETHOD(QueryInterface) (REFIID riid, LPVOID *ppUnk);
        STDMETHOD_(ULONG, AddRef) ();
        STDMETHOD_(ULONG, Release) ();

        // IMallocSpy methods
        STDMETHOD_(ULONG, PreAlloc) (ULONG cbRequest);
        STDMETHOD_(void *, PostAlloc) (void *pActual);

        STDMETHOD_(void *, PreFree) (void *pRequest, BOOL fSpyed);
        STDMETHOD_(void, PostFree) (BOOL fSpyed);

        STDMETHOD_(ULONG, PreRealloc) (void *pRequest, ULONG cbRequest,
                                       void **ppNewRequest, BOOL fSpyed);
        STDMETHOD_(void *, PostRealloc) (void *pActual, BOOL fSpyed);

        STDMETHOD_(void *, PreGetSize) (void *pRequest, BOOL fSpyed);
        STDMETHOD_(ULONG, PostGetSize) (ULONG cbActual, BOOL fSpyed);

        STDMETHOD_(void *, PreDidAlloc) (void *pRequest, BOOL fSpyed);
        STDMETHOD_(BOOL, PostDidAlloc) (void *pRequest, BOOL fSpyed, BOOL fActual);

        STDMETHOD_(void, PreHeapMinimize) ();
        STDMETHOD_(void, PostHeapMinimize) ();

    private:

        typedef std::map<void*, size_t> CPointerMap;
        CPointerMap m_Pointers;
        BOOL m_bTraceOn;
        DWORD m_nRequestedSize;
        DWORD m_RefCounter;
};

#endif //COMMALLOCSPYIMPL_H_INCLUDED
